Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/in_itron.h	(revision 387)
@@ -131,4 +131,5 @@
 extern ER_UINT	udp6_snd_dat (ID cepid, T_IPV6EP *p_dstaddr, void *data, int_t len, TMO tmout);
 extern ER_UINT	udp6_rcv_dat (ID cepid, T_IPV6EP *p_dstaddr, void *data, int_t len, TMO tmout);
+extern ER	udp6_can_cep(ID cepid, FN fncd);
 
 /* 【拡張機能】 */
@@ -139,4 +140,7 @@
 extern ER	udp_cre_cep (ID cepid, T_UDP_CCEP *pk_ccep);
 
+extern ER	udp6_del_cep(ID cepid);
+extern ER	udp6_set_opt(ID cepid, int_t optname, void *optval, int_t optlen);
+extern ER	udp6_get_opt(ID cepid, int_t optname, void *optval, int_t optlen);
 extern ER	udp6_cre_cep (ID cepid, T_UDP6_CCEP *pk_ccep);
 
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcp_input.c	(revision 387)
@@ -521,5 +521,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
@@ -847,5 +861,19 @@
 
 				/* 相手のアドレスをコピーする。*/
+
+#if defined(_IP6_CFG) && defined(_IP4_CFG)
+
+				if (cep->flags & TCP_CEP_FLG_IPV4) {
+					(*cep->p_dstaddr4).ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
+					(*cep->p_dstaddr4).portno = cep->dstaddr.portno;
+					}
+				else
+					*cep->p_dstaddr = cep->dstaddr;
+
+#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
+
 				*cep->p_dstaddr = cep->dstaddr;
+
+#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) */
 
 				if (IS_PTR_DEFINED(cep->callback)) {
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/tcpn_usrreq.c	(revision 387)
@@ -671,10 +671,10 @@
 		cep->p_myaddr4    = p_myaddr;
 		cep->p_dstaddr    = NULL;
-		cep->p_myaddr     = NULL;
+		cep->p_myaddr     = NADR;
 
 #else	/* of #if API_PROTO == API_PROTO_IPV4 */
 
 		cep->p_dstaddr4   = NULL;
-		cep->p_myaddr4    = NULL;
+		cep->p_myaddr4    = NADR;
 		cep->p_dstaddr    = p_dstaddr;
 		cep->p_myaddr     = p_myaddr;
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_output.c	(revision 387)
@@ -182,5 +182,5 @@
 #if defined(_IP6_CFG) && TNUM_UDP6_CEPID > 0
 
-		for (ix = tmax_udp6_cepid; ix -- > 0; ) {
+		for (ix = TNUM_UDP6_CEPID - 1; ix -- > 0; ) {
 
 			if (udp6_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
@@ -194,5 +194,5 @@
 #if defined(_IP4_CFG) && TNUM_UDP4_CEPID > 0
 
-		for (ix = tmax_udp4_cepid; ix -- > 0; ) {
+		for (ix = TNUM_UDP4_CEPID - 1; ix -- > 0; ) {
 
 			if (udp4_cep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udp_subr.c	(revision 387)
@@ -146,5 +146,5 @@
 #define UDP_FIND_CEP		udp6_find_cep
 #define UDP_NOTIFY		udp6_notify
-#define TMAX_UDP_CEPID		tmax_udp6_cepid
+#define TMAX_UDP_CEPID		(TNUM_UDP6_CEPID - 1)
 #define UDP_CEP			udp6_cep
 #define T_UDP_CEP		T_UDP6_CEP
@@ -183,5 +183,5 @@
 #define UDP_FIND_CEP		udp4_find_cep
 #define UDP_NOTIFY		udp4_notify
-#define TMAX_UDP_CEPID		tmax_udp4_cepid
+#define TMAX_UDP_CEPID		(TNUM_UDP4_CEPID - 1)
 #define T_UDP_CEP		T_UDP4_CEP
 #define UDP_CEP			udp4_cep
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udpn_usrreq.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udpn_usrreq.c	(revision 366)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netinet/udpn_usrreq.c	(revision 387)
@@ -308,16 +308,15 @@
 		else 
 			error = UDP_ALLOC_PORT(cep, pk_ccep->myaddr.portno);
-		
-                if (error == E_OK) {
-
-			/* UDP 通信端点生成情報をコピーする。*/
-			cep->cepatr        = pk_ccep->cepatr;			/* 通信端点属性		*/
-			cep->myaddr.ipaddr = pk_ccep->myaddr.ipaddr;		/* 自分のアドレス	*/
-			cep->callback      = (void*)pk_ccep->callback;		/* コールバック		*/
-
-			/* UDP 通信端点を生成済みにする。*/
-			cep->flags |= UDP_CEP_FLG_VALID;
-			}
-		}
+
+			if (error == E_OK) {
+				/* UDP 通信端点生成情報をコピーする。*/
+				cep->cepatr        = pk_ccep->cepatr;			/* 通信端点属性		*/
+				cep->myaddr.ipaddr = pk_ccep->myaddr.ipaddr;		/* 自分のアドレス	*/
+				cep->callback      = (void*)pk_ccep->callback;		/* コールバック		*/
+
+				/* UDP 通信端点を生成済みにする。*/
+				cep->flags |= UDP_CEP_FLG_VALID;
+				}
+			}
 
 	/* 通信端点のロックを解除する。*/
